//
//  FlickrPhotoAnnotation.m
//  PictureFly
//
//  Created by Jennifer Clark on 12/18/12.
//  Copyright (c) 2012 Jennifer Clark. All rights reserved.
//

#import "FlickrPhotoAnnotation.h"
#import "FlickrFetcher.h"

@implementation FlickrPhotoAnnotation
@synthesize photo = _photo;

+ (FlickrPhotoAnnotation *)annotationForPhoto:(NSDictionary *)photo //dictionary of Flickr photos
{
    FlickrPhotoAnnotation *annotation = [[FlickrPhotoAnnotation alloc] init];
    annotation.photo = photo;  
    return annotation;
}

- (NSString *)title
{
    return [self.photo objectForKey:FLICKR_PHOTO_TITLE];
}


- (NSString *)subtitle
{
    return [self.photo valueForKey:FLICKR_PHOTO_DESCRIPTION];
}

- (CLLocationCoordinate2D)coordinate
{
    CLLocationCoordinate2D coordinate;
    coordinate.latitude = [[self.photo objectForKey:FLICKR_LATITUDE]doubleValue];
    // coordinates are always doubles, dictionary returns an NSNumber
    coordinate.longitude = [[self.photo objectForKey:FLICKR_LONGITUDE]doubleValue];
    
    return coordinate;
}

@end
