//
//  ImageViewController.m
//  PictureFly
//
//  Created by Jennifer Clark on 12/13/12.
//  Copyright (c) 2012 Jennifer Clark. All rights reserved.
//

#import "ImageViewController.h"

@interface ImageViewController ()

@property (weak, nonatomic) IBOutlet UIImageView *imageView;
@property (weak, nonatomic) IBOutlet UIImageView *spinnerView;
@property (weak, nonatomic) IBOutlet UIImageView *spinnerViewPad;
@property (strong, nonatomic) UIActivityIndicatorView *spinner;

@end

@implementation ImageViewController
@synthesize imageView = _imageView, imageURL = _imageURL, spinnerView = _spinnerView, spinnerViewPad = _spinnerViewPad, spinner = _spinner;

- (UIActivityIndicatorView *)spinner
{
    if (!_spinner)  { 
        _spinner = [[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    }
    
    return  _spinner;
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


- (void)cropPhoto:(UIImage *)originalImage withFrame:(int)x andY:(int)y setWidth:(int)width setHeight:(int)height
{
    if (self.splitViewController) {
    CGSize size = [originalImage size];
    
        UIImageView *imageView = [[UIImageView alloc]init];
        
    [imageView setFrame:CGRectMake(0, 0, size.width, size.height)];
    [self.imageView addSubview:imageView];
    
    CGRect rect = CGRectMake (size.width / 2, size.height / 2 ,
                              (size.width / 3), (size.height / 1));
    
    [imageView setImage:[UIImage imageWithCGImage:CGImageCreateWithImageInRect([originalImage CGImage], rect)]];
    [imageView setFrame:CGRectMake(x, y, width, height)];
    [self.imageView addSubview:imageView];
    [self.imageView sendSubviewToBack:imageView];
    }
}

- (void)loadImage
{
    if (self.splitViewController) [self.spinnerViewPad addSubview:self.spinner];
        else  [self.spinnerView addSubview:self.spinner];

    [self.spinner startAnimating];
    [self.spinner hidesWhenStopped];
    
    dispatch_queue_t downloadQueue = dispatch_queue_create("flickr photo download", NULL);
    dispatch_async(downloadQueue, ^{
        NSData *imageData = [NSData dataWithContentsOfURL:self.imageURL];
        UIImage *image = [UIImage imageWithData:imageData];
        dispatch_async(dispatch_get_main_queue(), ^{
            //self.imageView.image = image;
            [self cropPhoto:image withFrame:0 andY:100 setWidth:320 setHeight:400];
             [self.spinner stopAnimating];
        });
    });
}


- (void)setImageURL:(NSURL *)imageURL
{
    _imageURL = imageURL;
    if (self.imageView.window) [self loadImage];
}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self loadImage];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    [self setImageView:nil];
    [self setSpinner:nil];
}

@end
